SystemOrganization addCategory: #'Khami-Integration-Facebook'!

WAComponent subclass: #SPFacebookAuthorizeComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Integration-Facebook'!

!SPFacebookAuthorizeComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 10:08'!
appId
	^self application preferenceAt: #facebookApplicationId! !

!SPFacebookAuthorizeComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 10:05'!
authorizeUrl
	^'https://www.facebook.com/dialog/oauth?client_id={1}&redirect_uri={2}' 
		format: {self appId. self canvasPage}! !

!SPFacebookAuthorizeComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 10:09'!
canvasPage
	^self application preferenceAt: #facebookCanvasPage! !

!SPFacebookAuthorizeComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 10:07'!
renderContentOn: html
	html script:  ('top.location.href=''{1}''' format: {self authorizeUrl}) ! !

TestCase subclass: #TestSPFacebookPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Integration-Facebook'!

!TestSPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 21:28'!
testSupportsRequest
	[ :r |  
		[self assert: (SPFacebookPlatform supportsRequest: r) ] 
			should lenient satisfy: [ r fields willReturn: (Dictionary new at: 'signed_request' put: 'foo'; yourself)]    
	  ] runScenario ! !

TestCase subclass: #TestSPFacebookUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Integration-Facebook'!

!TestSPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 13:38'!
testUsersWithSameIdAreEqual
! !

SPPlatform subclass: #SPFacebookPlatform
	instanceVariableNames: 'signedRequest graphApi user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Integration-Facebook'!

!SPFacebookPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 21:27'!
supportsRequest: aRequest
	^aRequest fields includesKey: 'signed_request'  ! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/25/2011 18:22'!
authorize: aRequestContext
	aRequestContext respond: [ :resp |
		resp
			contentType: WAMimeType textHtml;
			nextPutAll: (WAHtmlCanvas builder
				fullDocument: true;
				rootBlock: [ :root | 
					root title: 'Seaside'; beXhtml10Strict.
					root htmlAttributes at: 'xmlns' put: 'http://www.w3.org/1999/xhtml' ];
				render: [ :html | 	html script:  ('top.location.href=''{1}''' format: {self application authorizeUrl}) ]) ]! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:17'!
graphApi
	^graphApi ifNil: [ 
		signedRequest isAuthorized ifTrue: [ 
			graphApi := FBGraphAPI accessToken: signedRequest oauthToken ]]! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:08'!
initializeWithRequest: aRequest
	super initializeWithRequest: aRequest.
	signedRequest := FBSignedRequest decodeRequest: (aRequest fields at: 'signed_request').
! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:07'!
isLoggedIn
	^signedRequest notNil and: [signedRequest isAuthorized]! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:42'!
loginComponent
	^SPFacebookAuthorizeComponent! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:38'!
user
	^user ifNil: [ SPFacebookUser graphUser: self graphApi currentUser]! !

SPUser subclass: #SPFacebookUser
	instanceVariableNames: 'graphUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Integration-Facebook'!

!SPFacebookUser class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:39'!
graphUser: aUser
	^self basicNew
		initializeWithGraphUser: aUser;
		yourself.! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:24'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ graphUser = (anObject instVarNamed: #graphUser)! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:13'!
hash
	^graphUser hash! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:39'!
initializeWithGraphUser: aUser  
	self initialize.
	graphUser := aUser! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:44'!
name
	^graphUser name! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:45'!
pictureUrl
	^graphUser pictureUrl! !

WASystemConfiguration subclass: #SPFacebookConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Integration-Facebook'!

!SPFacebookConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 19:50'!
describeOn:  config
	(config string: #facebookApplicationId)
		group: #socialPlatform;
		comment: 'Facebook Application ID'.
		
	(config string: #facebookSecret)
		group: #socialPlatform;
		comment: 'Facebook Application Secret'.
		
	(config url: #facebookCanvasPage)
		group: #socialPlatform;
		comment: 'Facebook Canvas Page Url'! !
